/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package sfactor;

import java.io.*;
import java.util.Scanner;
import java.util.*;
/**
 *
 * @author ranjie
 */
public class FileIO {

    /**
     * @param args the command line arguments
     */
    private static ArrayList graphList;

    public static void main(String[] args) {
        //System.out.print("ddd" + getProjectPath());
        //graphList = readFileGetStrings("/home/ranjie/Desktop/code/graphList.txt");
        //saveResultPari(StabilityPolynomial.calculateloop(graphList),"/home/ranjie/Desktop/code/pariCode.txt");
        // TODO code application logic here
       // displayList(graphList);
    }

    public static ArrayList readFileGetStrings(String filePath)
    {
        ArrayList<String> aTeamList = new ArrayList<String>();//clear aTeamList
        try
        {
           FileReader fr = new FileReader(filePath);
           Scanner parser = new Scanner (fr);
           String teamName;
           while (parser.hasNextLine())
           {
               teamName = parser.nextLine();
               aTeamList.add(teamName);
           }
           fr.close();
        }

        catch(FileNotFoundException exception)
        {
           System.out.println(filePath + " not found");
        }
        catch(IOException exception)
        {
           System.out.println("Unexpected I/O error occured");
        }
        return aTeamList;
    }
    
    public static void writeStringsToFile(ArrayList<String> output, String filePath)
    {
        int countGraph = output.size();
        String contents[] = new String[countGraph];
        for(int i=0; i < countGraph; i++){
            contents[i] = output.get(i).toString();
        }

        try
        {
            PrintWriter outWriter = new PrintWriter(filePath);
            for(int i = 0; i < contents.length; i++)
                  outWriter.println(contents[i]);
            outWriter.close();
        }
        catch(IOException e)
        {
            System.out.println("Unexpected I/O error occured");
        }
    }

    public static void displayList(ArrayList<String> aList)
    {


        Iterator<String> outComeItertor = aList.iterator();
         while( outComeItertor.hasNext() )
        {
            //System.out.println("------------------------------");
            System.out.println(outComeItertor.next().toString());
        }
    }
    
    public static void saveResultPari(ArrayList<GraphPolynomial> resultList, String filePath)
    {
        ArrayList<String> pariCommands = new  ArrayList<String>();
        Iterator<GraphPolynomial> showResult = resultList.iterator();
         while( showResult.hasNext() )
        {
            GraphPolynomial anObject = showResult.next();
            pariCommands.add("factor(simplify("+ anObject.getPolynomial() + "))" );
            //pariCommands.add("simplify("+ anObject.getPolynomial() + ")" );
            //System.out.println("factor(simplify("+ anObject.getPolynomial() + "))" );
        }
        writeStringsToFile(pariCommands, filePath);
    }
    
    public static void runCommands(ArrayList<String> commands) throws IOException
    {
        FileIO.writeStringsToFile(commands, "running/run.sh");      
        File shRun = new File("running/run.sh");        
        //String projectFolderPath = shRun.getParentFile().getAbsolutePath();
        //String command = "sh "+shRun.getAbsolutePath();            
        //String command = "sh /home/ranjie/NetBeansProjects/sfactor/running/run.sh";
        Process p = Runtime.getRuntime().exec("sh "+shRun.getAbsolutePath());
    }
    
    public static String getProjectPath(){
//        File shRun = new File("ReadMe.txt"); 
//        String projectFolderPath = shRun.getParentFile().getAbsolutePath();
//        return projectFolderPath;
        return "/home/ranjie/NetBeansProjects/sfactor/";
    }
    
    public static void saveSFactorsList(ArrayList< String[]> sFactorsList){
        ArrayList<String> SFsaveList = new ArrayList<String>();
        for (String[] anFinding : sFactorsList ){
            SFsaveList.add( anFinding[0]
                    + "=" +anFinding[1]+ "X" + anFinding[2]);
            //System.out.println("-----------");
        }
        writeStringsToFile(SFsaveList,"running/sFactors.txt");
    }
    
    public static void saveSFactorsList(ArrayList< String[]> sFactorsList, String filePath){
        ArrayList<String> SFsaveList = new ArrayList<String>();
        for (String[] anFinding : sFactorsList ){
            SFsaveList.add( anFinding[0]
                    + "=" +anFinding[1]+ "X" + anFinding[2]);
            //System.out.println("-----------");
        }
        writeStringsToFile(SFsaveList,filePath);
    }
    
    public static void savePolyIDsList(ArrayList<PolyIDs> polyIDsList, String savePath){
        ArrayList<String> saveStringsList = new ArrayList<String>();
        int index = 0;
        for (PolyIDs instance : polyIDsList){
            saveStringsList.add("[NO"+ index + "]" +"[Polynomial Factors]");    
            ArrayList<Factor> factorsList = instance.getFactorsList();
            for (Factor afactor : factorsList){
                saveStringsList.add("(" + afactor.getBody()+")"+"^"+ afactor.getPower());
            }           
            ArrayList<String> IDs = instance.getIDs();
            saveStringsList.add("[NO"+ index + "]" +"[same polynomial graphs]");
            for (String ID : IDs){
                saveStringsList.add("[NO"+ index + "]" +"[Graph]"+ID);
            }
            index++;
        }
        writeStringsToFile(saveStringsList,savePath);
    }
    
    public static ArrayList<PolyIDs> readPolyIDsList(String filePath){
        ArrayList<String> inputStringsList = readFileGetStrings(filePath);
        ArrayList<PolyIDs> polynomialsList = new ArrayList<PolyIDs>();
        int countPoly = 0;
        for ( String line : inputStringsList){
            if ( line.indexOf("Polynomial Factors") != -1 ){//[NO0][Polynomial Factors], new Polynomail and ID record
                PolyIDs newPoly = new PolyIDs();
                polynomialsList.add(newPoly);
                countPoly++ ; //1
            }else if ( line.indexOf("(") != -1 && line.indexOf("^") != -1) {
                // is a factor              
                //convert this line to a factor
                Factor lineFactor = ResultConverter.strToFactorPolyIDs(line);                
                // insert to current working polynomial
                polynomialsList.get(countPoly-1).getFactorsList().add(lineFactor);//index=num-1
            }else if ( line.indexOf("Graph") != -1) {
                // is a graph ID       [NO2][Graph]111       
                //convert this line to a factor
                String[] cutTab = line.split("Graph\\]");// {[NO2]},{111} 
                String graphIDStr = cutTab[1];//{111}
                polynomialsList.get(countPoly-1).getIDs().add(graphIDStr);//index=num-1
            }
             
        }    
        
        return polynomialsList;

    }
    
    public static ArrayList< String[]> readSFactorsList(String filePath){
        ArrayList< String[]> sFactorsList = new ArrayList< String[]>();
        ArrayList<String> SFsaveList = readFileGetStrings(filePath);
        for ( String anFinding : SFsaveList){
        String sfactor[] = new String[3];
        sfactor[0] = anFinding.split("=")[0];
        String factors = anFinding.split("=")[1];
        sfactor[1] = factors.split("X")[0];
        sfactor[2] = factors.split("X")[1];
        sFactorsList.add(sfactor);           
        }
        
        return sFactorsList;
    }
    
    public static ArrayList< String> readSFactorsListHead(String filePath){
        ArrayList< String> sFactorsList = new ArrayList< String>();
        ArrayList<String> SFsaveList = readFileGetStrings(filePath);
        for ( String anFinding : SFsaveList){
        String sfactor = anFinding.split("=")[0];
        sFactorsList.add(sfactor);           
        }
        
        return sFactorsList;
    }




}
