/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package sfactor;

import java.util.ArrayList;

/**
 *
 * @author ranjie
 */
public class PolynomialRecord implements Cloneable {

    private String id;
    private ArrayList<Factor> factorsList = new ArrayList<Factor>();

    public PolynomialRecord()
    {
        // initialise instance variables
        factorsList = new ArrayList<Factor>();

    }
    
    
    
    public String getId(){return id;}
    public ArrayList<Factor> getFactorsList(){return factorsList;}

    public void setId(String newId){id = newId;}
    public void setFactorsList(ArrayList<Factor> newFactorsList){factorsList= newFactorsList;}
    
    public static boolean polynomialEqual(PolynomialRecord poly1,PolynomialRecord poly2){
        ArrayList<Factor> poly1Factors = poly1.getFactorsList();
        ArrayList<Factor> poly2Factors = poly2.getFactorsList();
        int num = poly1Factors.size();
        int num2 = poly2Factors.size();
        boolean polyEqual = true;

        if(poly2Factors.size()!= num){polyEqual= false;}


        boolean factorsEqual[]= new boolean[num];
        for(int i = 0; i< num; i++){
            factorsEqual[i]=false;
            String factorBody1 = poly1Factors.get(i).getBody();
            for(int j = 0; j < num2; j++){
                String factorBody2 = poly2Factors.get(j).getBody();
                if (factorBody1.equals(factorBody2)
                        && poly1Factors.get(i).getPower()== poly2Factors.get(j).getPower() )
                    factorsEqual[i]=true;//find the same one, than true
            }
        }
        for (int i=0; i < num; i++ ){
            if (factorsEqual[i] == false )
                polyEqual = false;
        }
        
        return polyEqual;
    }
}
