package sfactor;

import java.io.File;
import java.io.IOException;
import java.util.*;

/**
 * Write a description of class Stability here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 *
 *
 * notes
 * 1. to StabilityPolynomial.java take graphList.txt as input
 * and compute A(G;p) for each graph. and assemble pari command as
 * simply((1-p)^2+p^3),output to file "pariCode.txt"
 * run command
 * 
 * gp < pariCode.txt > pariResult.txt
 * 
 * store the results (normalized )at
 *
 *
 */
public class StabilityPolynomial
{
    // instance variables - replace the example below with your own
    private int x;
    private double p = 0.5;
    private int graph1[][] ={
            {0,1,1},
            {1,0,1},
            {1,1,0}
        };
        
    private int graph2[][] ={
            {0,1,0,1},
            {1,0,1,1},
            {0,1,0,1},
            {1,1,1,0},
        };
        
    private int graph3[][] ={
            {0,1,1,1},
            {1,0,1,1},
            {1,1,0,1},
            {1,1,1,0},
        };
    
    private int graph4[][] ={
            {0,1,0,0,1},
            {1,0,1,1,0},
            {0,1,0,1,1},
            {0,1,1,0,1},
            {1,0,1,1,0},
        };
        
    public int[][] GMatrix = graph4;
    //a graph is given

    
    public int rows = GMatrix.length;
    public int columns = GMatrix[0].length;
    //private int rows=4;
    //private int columns = 4;
    

    /**
     * Constructor for objects of class Stability
     */
    

    public String recurseSta(List<Integer> aliveList)
    {
        //System.out.println("----aliveList ------" );
        
               
        List<Integer> stillAlive = new ArrayList<Integer>();
        List<Integer> aliveListNotV = new ArrayList<Integer>();
        for ( int i : aliveList){
            stillAlive.add(i);
            aliveListNotV.add(i);
        }
         
        if ( aliveList.size() <= 1){
            //System.out.println("----base case return 1------" );
            //for ( int n : aliveList)
            //   System.out.println("" + n);
            return "1";
        }
        
        else {
            aliveListNotV.remove(0);
             
            List<Integer> aliveListPickV = new ArrayList<Integer>();
            for ( int i : cutVnNeighbour(stillAlive)){
              aliveListPickV.add(i);
            }
            int neighbourCount = aliveList.size() - aliveListPickV.size() - 1;
            
            //System.out.println("----alive List NOT V------" );
            //for ( int n : aliveListNotV)
            //  System.out.println("" + n);
            
            
            String offspringStr = recurseSta(aliveListNotV);
            String staNot ="";  
            if (offspringStr.equals("1"))
                staNot = "(1-p)";
            else
                staNot = "(1-p)*("+ offspringStr +")";
            
   
            //double m = Math.pow(2,n);
            //System.out.println("----alive List Pick V------" );
            //for ( int n : aliveListPickV)
            //  System.out.println("" + n);
            
            //p*(1-p)^2*staYes
            String notpPower = "";
            if (neighbourCount >= 2 ){
                notpPower = "*(1-p)^"+ neighbourCount;
            }
            if (neighbourCount == 1 ){
                notpPower = "*(1-p)";
            }
            
            String staYesHead = "";   
            staYesHead = "p" + notpPower;
            
            String staYesEnd = recurseSta(aliveListPickV);
  
            String staYes = "";
            if (staYesEnd.equals("1")|| staYesEnd.equals(""))
               staYes = staYesHead;
            else
               staYes = staYesHead + "*("+ staYesEnd +")";
            

            
            return staNot + "+" + staYes;
        }
    }
    
   
    public static void showMatrix(int[][] aMatrix) {
        int M = aMatrix.length;
        int N = aMatrix[0].length;
        for (int i = 0; i < M; i++) {
            for (int j = 0; j < N; j++)
                System.out.print(aMatrix[i][j]);
            System.out.println();
        }
    }
    
    private List<Integer> cutVnNeighbour(List<Integer> aliveList){
        
        if (aliveList.size() <= 1)
          System.out.println("input of cutVnNeighbout is not correct, aliveList.size = "  + aliveList.size());
        
        List<Integer> aliveListV = aliveList;
   
        int indexV = aliveList.get(0);
        //get the index of vertex V, which we are going to inspect.
        
        List<Integer> neighbourList =  new ArrayList<Integer>();
        //record all the neighbour vertice
        
        //check row indexV of Matrix, if find "1", record the index of this neighbour
        for (int n = columns-1; n >= 0 ; n = n-1){
            if ( GMatrix[indexV][n] == 1){
                neighbourList.add(n);
            }
        }
        //neighbourList ready, compare it with aliveList
        
        int aLiveNum = aliveListV.size();
        for (int i = aLiveNum-1; i >= 0; i = i-1){
            boolean delFlag = false;
            for (int neiIndex : neighbourList){
                if (aliveListV.get(i) == neiIndex){
                    //kill alive neighbours
                    delFlag = true;
                }   
            }
            if ( delFlag == true )
               aliveListV.remove(i);
        }
        //be aware that the killing goes from the bottom to the top
        //so that the killing will not effect the index of neighbours in alive list.
        
        //kill V himself -----------------------
        //be aware that in matrix the value of itself must be 0.
        if (aliveListV.size()>0)
            aliveListV.remove(0);
  
        return aliveListV;    
    }
    
    
    
    public String getStability(){             
        List<Integer> aliveList = new ArrayList<Integer>();       
        for(int i = 0; i < rows; i++){
            aliveList.add(i);
        }
            
        String staPoly = recurseSta(aliveList);
        //System.out.println("----overall---stability ------" );
        //System.out.println("Stability Polynomial =  " + staPoly );
        return staPoly;
    }

    public String getStability(String graphId){

        GMatrix=idToMatrix(graphId);
        rows = GMatrix.length;
        columns = GMatrix[0].length;
        // Important, the Matrix for checking is updated according to current
        // graph Id. This Matrix will not be modified during the whole computation
        // process of this graph.

        List<Integer> aliveList = new ArrayList<Integer>();
        for(int i = 0; i < rows; i++){
            aliveList.add(i);
        }

        String staPoly = recurseSta(aliveList);
        //System.out.println("----overall---stability ------" );
        //System.out.println("Stability Polynomial =  " + staPoly );
        return staPoly;
    }

    public static int[][] idToMatrix(String id) {
        int length = id.length();
        int matrixSize = (int)(Math.sqrt(2*length) + 1);
        //System.out.println(" this graph has "+ matrixSize + " vertices");
        int graphMatrix[][] = new int[matrixSize][matrixSize];
        
        int index = 0;
        for(int i = 0; i < matrixSize; i++){
            for ( int j= i+1; j < matrixSize; j++){
                if (index >=length){
                   throw new  IllegalArgumentException("Invalid graph id");
                }

                String readbit = id.substring(index, index+1);
       
                graphMatrix[i][j]= Integer.parseInt( readbit );
                graphMatrix[j][i]= graphMatrix[i][j];
                index++;
            }
        }
        //showMatrix(graphMatrix);
        return graphMatrix;
    }
    

    public static ArrayList<GraphPolynomial> calculateloop(ArrayList<String> graphList) {
        
        
        ArrayList<GraphPolynomial> resultList = new ArrayList<GraphPolynomial>();      
        StabilityPolynomial calculater1 = new StabilityPolynomial();
        String tempPoly;
        int countGraph = graphList.size();
        for (int i=0; i< countGraph; i++){
            String currentGraph = graphList.get(i).toString();
            tempPoly = calculater1.getStability(currentGraph);
            GraphPolynomial aResult = new GraphPolynomial();
            aResult.setId(currentGraph);
            aResult.setPolynomial(tempPoly);
            //System.out.println("   stability Polynomial = " + tempPoly);
            resultList.add(aResult);
        }

       return resultList;
       //String staPoly = test1.getStability("1111111111000001111110000000111111119999999991111111111");
        
        //System.out.println("   stability Polynomial = ");
        
        //FileIO.displayList(FileIO.readFileGetStrings());
        //idToMatrix("010101010101110");

    }
    
    public static void graphListToPariResult() throws IOException {
         ArrayList<String> graphList = FileIO.readFileGetStrings("running/graphList.txt");
        //FileIO.displayList(graphList);
        //List of graphs ready

        ArrayList<GraphPolynomial> resultList = calculateloop(graphList);
        
        //FileIO.saveResultPari(resultList, "/home/ranjie/Desktop/code/pariCode.txt");
        FileIO.saveResultPari(resultList, "running/pariCode.txt");
        
        //showMatrix(idToMatrix("111111"));      
        ArrayList<String> ddd= new ArrayList<String>();
        String command1 = "gp < /home/ranjie/NetBeansProjects/sfactor/running/pariCode.txt > /home/ranjie/NetBeansProjects/sfactor/running/pariResult.txt";
        ddd.add(command1);
        FileIO.runCommands(ddd);
        //graphList.txt ==>> pariResult.txt
    }
    
     public static void run() throws IOException {
         ArrayList<String> graphList = FileIO.readFileGetStrings("running/graphList.txt");
        //FileIO.displayList(graphList);
        //List of graphs ready

        ArrayList<GraphPolynomial> resultList = calculateloop(graphList);
        
        //FileIO.saveResultPari(resultList, "/home/ranjie/Desktop/code/pariCode.txt");
        FileIO.saveResultPari(resultList, "running/pariCode.txt");
        
        //showMatrix(idToMatrix("111111"));      
        ArrayList<String> ddd= new ArrayList<String>();
        String command1 = "gp < /home/ranjie/NetBeansProjects/sfactor/running/pariCode.txt > /home/ranjie/NetBeansProjects/sfactor/running/pariResult.txt";
        ddd.add(command1);
        FileIO.runCommands(ddd);
        //graphList.txt ==>> pariResult.txt
    }


    
    public static void main(String[] args) throws IOException {
        run();                    
    }
    
    
    
}
