/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sfactor;

import java.io.IOException;
import java.util.*;

/**
 *
 * @author ranjie
 */

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 * 
 * 
 * Read Me
 * 1)put graphList.txt in running folder
 * 2)run StabilityPolynomial.java
 * 3)run GeneralUse.java
 */

public class GeneralUse {

    public static ArrayList< String[]> findSFactor(String graphListPath, String pariResultPath) {
        ArrayList<PolynomialRecord> polynomialsList = ResultConverter.Normalization(graphListPath,pariResultPath);
        int n = polynomialsList.size();
        ArrayList< String[]> sFactorsList = new ArrayList< String[]>();

        for (int i = 0; i < n; i++){
            PolynomialRecord polyProduct = new PolynomialRecord();
            polyProduct = polynomialsList.get(i);
            for (int j = 0; j< n; j++) {
                PolynomialRecord polyDivide = polynomialsList.get(j);

                if (polyDivisionCheck(polyProduct, polyDivide)){
                    PolynomialRecord polyLeft = polyDivision(polyProduct,polyDivide);
                    boolean find = false;
                    for (int k = j+1 ; k < n; k++){
                        if (polynomialEqual(polynomialsList.get(k),polyLeft)){
                            String sfactor[] = new String[3];
                            sfactor[0]= polynomialsList.get(i).getId();
                            sfactor[1]= polynomialsList.get(j).getId();
                            sfactor[2]= polynomialsList.get(k).getId();
                            sFactorsList.add(sfactor);
                            find = true;
                        }
                    }//go through the whole list again, check if left part has company
                }//if
            }

        }//check every polynomial if it is a production of any other two polys

        return sFactorsList;

    }
    
    public static ArrayList< String[]> findSFactorPolyIDs(ArrayList<PolyIDs> polyIDsList) {
        ArrayList<PolyIDs> polynomialsList = polyIDsList;
        int n = polynomialsList.size();
        ArrayList< String[]> sFactorsList = new ArrayList< String[]>();

        for (int i = 0; i < n; i++){
            PolyIDs polyProduct = new PolyIDs();
            polyProduct = polynomialsList.get(i);
            for (int j = 0; j< n; j++) {
                PolyIDs polyDivide = polynomialsList.get(j);

                if (polyDivisionCheck(polyProduct, polyDivide)){
                    PolyIDs polyLeft = polyDivision(polyProduct,polyDivide);
                    boolean find = false;
                    for (int k = j+1 ; k < n; k++){
                        if (polynomialEqual(polynomialsList.get(k),polyLeft)){
                            String sfactor[] = new String[3];
                            sfactor[0]= i+"";
                            sfactor[1]= j+"";
                            sfactor[2]= k+"";
                            sFactorsList.add(sfactor);
                            find = true;
                        }
                    }//go through the whole list again, check if left part has company
                }//if
            }

        }//check every polynomial if it is a production of any other two polys

        return sFactorsList;

    }

    public static ArrayList< String[]> findSFactorVisible(String graphListPath, String pariResultPath) {
        ArrayList<PolynomialRecord> polynomialsList = ResultConverter.Normalization(graphListPath,pariResultPath);
        int n = polynomialsList.size();
        ArrayList< String[]> sFactorsList = new ArrayList< String[]>();
        
        int count = 0;
        for (int i = 0; i < n; i++){
            count++;
            if (count == 51){
                count = 1;
                System.out.println("working on graph index " + i);
            }
            PolynomialRecord polyProduct = new PolynomialRecord();
            polyProduct = polynomialsList.get(i);
            for (int j = 0; j< n; j++) {
                PolynomialRecord polyDivide = polynomialsList.get(j);

                if (polyDivisionCheck(polyProduct, polyDivide)){//can be divided
                    PolynomialRecord polyLeft = polyDivision(polyProduct,polyDivide);//quotient
                    boolean find = false;
                    for (int k = j+1 ; k < n; k++){
                        if (polynomialEqual(polynomialsList.get(k),polyLeft)){
                            String sfactor[] = new String[3];
                            sfactor[0]= polynomialsList.get(i).getId();
                            sfactor[1]= polynomialsList.get(j).getId();
                            sfactor[2]= polynomialsList.get(k).getId();
                            sFactorsList.add(sfactor);
                            find = true;
                        }
                    }//go through the whole list again, check if left part has company
                }//if
            }

        }//check every polynomial if it is a production of any other two polys

        return sFactorsList;

    }

    
    public static void displaySFactorsList(ArrayList< String[]> sFactorsList){
        System.out.println("we have " + sFactorsList.size() + "  sfactors");
        for (String[] anFinding : sFactorsList ){
            System.out.println( anFinding[0]
                    + "=" +anFinding[1]+ "X" + anFinding[2]);
            //System.out.println("-----------");
        }
    }

    public static boolean polynomialEqual(PolynomialRecord poly1,PolynomialRecord poly2){
        ArrayList<Factor> poly1Factors = poly1.getFactorsList();
        ArrayList<Factor> poly2Factors = poly2.getFactorsList();
        int num = poly1Factors.size();
        int num2 = poly2Factors.size();
        boolean polyEqual = true;

        if(poly2Factors.size()!= num){polyEqual= false;}

        boolean factorsEqual[]= new boolean[num];
        for(int i = 0; i< num; i++){
            factorsEqual[i]=false;
            String factorBody1 = poly1Factors.get(i).getBody();
            for(int j = 0; j < num2; j++){
                String factorBody2 = poly2Factors.get(j).getBody();
                if (factorBody1.equals(factorBody2)
                        && poly1Factors.get(i).getPower()== poly2Factors.get(j).getPower() )
                    factorsEqual[i]=true;//find the same one, than true
            }
        }
        for (int i=0; i < num; i++ ){
            if (factorsEqual[i] == false )
                polyEqual = false;
        }
        
        return polyEqual;
    }
    
    public static boolean polynomialEqual(PolyIDs poly1,PolyIDs poly2){
        ArrayList<Factor> poly1Factors = poly1.getFactorsList();
        ArrayList<Factor> poly2Factors = poly2.getFactorsList();
        int num = poly1Factors.size();
        int num2 = poly2Factors.size();
        boolean polyEqual = true;

        if(poly2Factors.size()!= num){polyEqual= false;}

        boolean factorsEqual[]= new boolean[num];
        for(int i = 0; i< num; i++){
            factorsEqual[i]=false;
            String factorBody1 = poly1Factors.get(i).getBody();
            for(int j = 0; j < num2; j++){
                String factorBody2 = poly2Factors.get(j).getBody();
                if (factorBody1.equals(factorBody2)
                        && poly1Factors.get(i).getPower()== poly2Factors.get(j).getPower() )
                    factorsEqual[i]=true;//find the same one, than true
            }
        }
        for (int i=0; i < num; i++ ){
            if (factorsEqual[i] == false )
                polyEqual = false;
        }
        
        return polyEqual;
    }

    public static void testPolynomialEqual(){
        Factor factor1 = new Factor();
        factor1.setBody("3+p");
        factor1.setPower(4);

        Factor factor2 = new Factor();
        factor2.setBody("2+p");
        factor2.setPower(4);

        Factor factor3 = new Factor();
        factor3.setBody("2+p");
        factor3.setPower(1);

        Factor factor4 = new Factor();
        factor4.setBody("3+p");
        factor4.setPower(4);

        Factor factor5 = new Factor();
        factor5.setBody("2-p");
        factor5.setPower(2);

        PolynomialRecord poly1 = new PolynomialRecord();
        poly1.getFactorsList().add(factor1);
        poly1.getFactorsList().add(factor2);
        poly1.setId("10100101");

        PolynomialRecord poly2 = new PolynomialRecord();
        poly2.getFactorsList().add(factor3);
        poly2.getFactorsList().add(factor4);
        //poly2.getFactorsList().add(factor5);
        poly2.setId("111111101");

        boolean ans = polynomialEqual(poly1,poly2);
        System.out.println("equal test is " + ans);

    }


    public static PolynomialRecord polyDivision(PolynomialRecord polyProduction, PolynomialRecord polyDivisor) {
        // Production/Divisor

        ArrayList<Factor> divideFactors = polyDivisor.getFactorsList();

        ArrayList<Factor> productFactors = polyProduction.getFactorsList();
        
        ArrayList<Factor> leftFactors = new ArrayList<Factor>();
        for (int i=0; i < productFactors.size(); i++){
            Factor tempFactor = new Factor();
            tempFactor.setBody(productFactors.get(i).getBody());
            tempFactor.setPower(productFactors.get(i).getPower());
            leftFactors.add(tempFactor);
        }//copy productFactors

        
        //Factor emptyFactor = new Factor();
        //for(int i = 0; i < productFactors.size(); i++){
        //    leftFactors.add(emptyFactor);
        //}

        for (int i=0; i < divideFactors.size(); i++ ){
            //check if this aDivideFactor can be divided
            for (int j=0; j < productFactors.size(); j++){// j >= i  
                if ( divideFactors.get(i).getBody().equals(productFactors.get(j).getBody() ) ){
                    int diverPower = divideFactors.get(i).getPower();
                    int productorPower = productFactors.get(j).getPower();
                    int leftPower = productorPower - diverPower;
                    leftFactors.get(j).setPower(leftPower);
                }
            }
        }//all divFactors done

        int num = leftFactors.size();
        for (int i = num-1; i >= 0 ; i-- ){//remove objects, not effecting the index
            if (leftFactors.get(i).getPower()<=0)
                leftFactors.remove(i);
        }// remove dead factor

        PolynomialRecord leftPolynomial = new PolynomialRecord();// may have problem about copy
        leftPolynomial.setFactorsList(leftFactors);

        return leftPolynomial;

    }

    public static PolyIDs polyDivision(PolyIDs polyProduction, PolyIDs polyDivisor) {
        // Production/Divisor

        ArrayList<Factor> divideFactors = polyDivisor.getFactorsList();

        ArrayList<Factor> productFactors = polyProduction.getFactorsList();
        
        ArrayList<Factor> leftFactors = new ArrayList<Factor>();
        for (int i=0; i < productFactors.size(); i++){
            Factor tempFactor = new Factor();
            tempFactor.setBody(productFactors.get(i).getBody());
            tempFactor.setPower(productFactors.get(i).getPower());
            leftFactors.add(tempFactor);
        }//copy productFactors

        
        //Factor emptyFactor = new Factor();
        //for(int i = 0; i < productFactors.size(); i++){
        //    leftFactors.add(emptyFactor);
        //}

        for (int i=0; i < divideFactors.size(); i++ ){
            //check if this aDivideFactor can be divided
            for (int j=0; j < productFactors.size(); j++){// j >= i  
                if ( divideFactors.get(i).getBody().equals(productFactors.get(j).getBody() ) ){
                    int diverPower = divideFactors.get(i).getPower();
                    int productorPower = productFactors.get(j).getPower();
                    int leftPower = productorPower - diverPower;
                    leftFactors.get(j).setPower(leftPower);
                }
            }
        }//all divFactors done

        int num = leftFactors.size();
        for (int i = num-1; i >= 0 ; i-- ){//remove objects, not effecting the index
            if (leftFactors.get(i).getPower()<=0)
                leftFactors.remove(i);
        }// remove dead factor

        PolyIDs leftPolynomial = new PolyIDs();// may have problem about copy
        leftPolynomial.setFactorsList(leftFactors);

        return leftPolynomial;

    }


    public static boolean polyDivisionCheck(PolynomialRecord polyProduction, PolynomialRecord polyDivisor) {
        // DividEnd/Divisor
        boolean canDivide = false;
        ArrayList<Factor> divideFactors = polyDivisor.getFactorsList();
        ArrayList<Factor> productFactors = polyProduction.getFactorsList();

        boolean canDivideFactor[] = new boolean[divideFactors.size()];//each divfactor have a flag

        for (int i=0; i < divideFactors.size(); i++ ){
            //check if this aDivideFactor can be divided
            canDivideFactor[i]= false;
            for (Factor aProductFactor : productFactors){
                if ( divideFactors.get(i).getBody().equals(aProductFactor.getBody())
                    && divideFactors.get(i).getPower() <= aProductFactor.getPower() )
                    canDivideFactor[i]= true;
            }
        }//all DivideFactor check, flag set canDivideFactor[] ready

        canDivide = true;
        for (int i=0; i < divideFactors.size(); i++ ){
            if (canDivideFactor[i]== false )
                canDivide = false;
        }//if any one failed, all failed

        return canDivide;
    }

    public static boolean polyDivisionCheck(PolyIDs polyProduction, PolyIDs polyDivisor) {
        // DividEnd/Divisor
        boolean canDivide = false;
        ArrayList<Factor> divideFactors = polyDivisor.getFactorsList();
        ArrayList<Factor> productFactors = polyProduction.getFactorsList();

        boolean canDivideFactor[] = new boolean[divideFactors.size()];//each divfactor have a flag

        for (int i=0; i < divideFactors.size(); i++ ){
            //check if this aDivideFactor can be divided
            canDivideFactor[i]= false;
            for (Factor aProductFactor : productFactors){
                if ( divideFactors.get(i).getBody().equals(aProductFactor.getBody())
                    && divideFactors.get(i).getPower() <= aProductFactor.getPower() )
                    canDivideFactor[i]= true;
            }
        }//all DivideFactor check, flag set canDivideFactor[] ready

        canDivide = true;
        for (int i=0; i < divideFactors.size(); i++ ){
            if (canDivideFactor[i]== false )
                canDivide = false;
        }//if any one failed, all failed

        return canDivide;
    }
    

    public static void testDivisionCheck(){
        Factor factor1 = new Factor();
        factor1.setBody("1+p");
        factor1.setPower(2);

        Factor factor2 = new Factor();
        factor2.setBody("2+p");
        factor2.setPower(3);

        Factor factor3 = new Factor();
        factor3.setBody("2+p");
        factor3.setPower(3);

        Factor factor4 = new Factor();
        factor4.setBody("1+p");
        factor4.setPower(2);

        Factor factor5 = new Factor();
        factor5.setBody("2-p");
        factor5.setPower(2);

        PolynomialRecord poly1 = new PolynomialRecord();
        poly1.getFactorsList().add(factor1);
        //poly1.getFactorsList().add(factor2);
        poly1.setId("10100101");

        PolynomialRecord poly2 = new PolynomialRecord();
        poly2.getFactorsList().add(factor3);
        poly2.getFactorsList().add(factor4);
        //poly2.getFactorsList().add(factor5);
        poly2.setId("111111101");

        boolean result = polyDivisionCheck(poly2, poly1);
        System.out.print("test result is " + result);

    }

    public static void Debug(String graphListPath, String pariResultPath) {
        ArrayList<PolynomialRecord> polynomialsList = ResultConverter.Normalization(graphListPath,pariResultPath);
        ResultConverter.displayPolynomial(polynomialsList.get(polynomialsList.size()-1));

    }


    public static void showSFactorResult(String graphListPath, String pariResultPath) {
        //ArrayList<PolynomialRecord> polynomialsList = ResultConverter.Normalization("graphList.txt","pariResultFake.txt");
        //ResultConverter.displayPolyRecords(polynomialsList);
        //testDivisionCheck();
        //testDivision();
        //testPolynomialEqual();
        
        ArrayList< String[]> sFactorsList = findSFactor(graphListPath,pariResultPath);
        displaySFactorsList(sFactorsList);

        //Debug("graphList.txt","pariResult.txt");
        int size = sFactorsList.size();
        for(int i=size-1; i >=0 ; i--){
            if ( sFactorsList.get(i)[1].equals("1") ||sFactorsList.get(i)[2].equals("1") )
                     sFactorsList.remove(i);
        }

        System.out.println("---------excluding divisor graphID=1----------");
        displaySFactorsList(sFactorsList);
        
        
    }
    
//    public static int countSFGraphs() {
//       ArrayList< String[]> sFactorsList = FileIO.readSFactorsList("running/sFactors.txt");
//       ArrayList< String > SFGraphs = new ArrayList< String >();
//       for (String[] anFinding : sFactorsList ){
//           SFGraphs.add(anFinding[0]);
//       }
//       //FileIO.displayList(SFGraphs);
//       int size = SFGraphs.size();
//       int count = size;
//       boolean distinct = true;
//       //System.out.println(SFGraphs.size());
//       for (int i=0; i < size-1; i++){
//           distinct = true;
//           for (int j= i+1; j< size; j++){
//                if (SFGraphs.get(i).equals(SFGraphs.get(j))){
//                    distinct=false;
//                }
//           }
//           if (!distinct) count--;
//       }
//       return count;
//    }
    
    public static int countSFGraphs2(ArrayList<String>inSFGraphs) {
       ArrayList< String> SFGraphs = inSFGraphs;
       //FileIO.displayList(SFGraphs);
       int size = SFGraphs.size();
       int count = size;
       boolean distinct = true;
       System.out.println(SFGraphs.size());
       for (int i=1; i < size; i++){
           distinct = true;
           for (int j= 0; j< i; j++){
                if (SFGraphs.get(i).equals(SFGraphs.get(j))){
                    distinct=false;
                }
           }
           if (!distinct) count--;
       }
       return count;
    }
    
    public static ArrayList<String> distinctSFGraphs(ArrayList<String> inSFGraphs) {
       ArrayList< String> SFGraphs = inSFGraphs;
       //FileIO.displayList(SFGraphs);
       int size = SFGraphs.size();
       int sizeEnd = size;
       System.out.println(SFGraphs.size());
       for (int i= size-2; i >= 0; i--){
           for (int j= sizeEnd-1; j> i; j--){
                if (SFGraphs.get(i).equals(SFGraphs.get(j))){
                    SFGraphs.remove(i);
                }
           }
           sizeEnd = SFGraphs.size();
       }
       return SFGraphs;
    }
    
    public static int countSFGraphs3() {
       ArrayList< String> SFGraphs = FileIO.readSFactorsListHead("running/sFactors.txt");
       //FileIO.displayList(SFGraphs);
       int size = SFGraphs.size();
       int count = size;
       System.out.println(SFGraphs.size());
       for (int i=1; i < size; i++){
            if (SFGraphs.get(i).equals(SFGraphs.get(i-1))){
                count--;
            }       
       }
       return count;
    }
    
    

    public static void fullTest() throws IOException{
        //findSFactor("graphList.txt","pariResult.txt");
        //StabilityPolynomial.run();
        ArrayList<String> rawStr = FileIO.readFileGetStrings("running/graphList.txt");
        System.out.println("graph number:" + rawStr.size());
        
        ArrayList< String[]> sFactorsList = findSFactor("running/graphList.txt","running/pariResult.txt");
        //displaySFactorsList(sFactorsList);
        FileIO.saveSFactorsList(sFactorsList);
        displaySFactorsList(FileIO.readSFactorsList("running/sFactors.txt"));
    }
    
    public static void graphListToSFactors() throws IOException{
        //findSFactor("graphList.txt","pariResult.txt");
        //StabilityPolynomial.run();
        ArrayList<String> rawStr = FileIO.readFileGetStrings("running/graphList.txt");
        System.out.println("graph number:" + rawStr.size());
        
        ArrayList< String[]> sFactorsList = findSFactor("running/graphList.txt","running/pariResult.txt");
        //displaySFactorsList(sFactorsList);
        FileIO.saveSFactorsList(sFactorsList);
        displaySFactorsList(FileIO.readSFactorsList("running/sFactors.txt"));
    }
    
    public static void graphListToSFactorsVisible(String graphListPath, String pariResultPath) throws IOException{
        //findSFactor("graphList.txt","pariResult.txt");
        //StabilityPolynomial.run();
        ArrayList<String> rawStr = FileIO.readFileGetStrings(graphListPath);
        System.out.println("graph number:" + rawStr.size());
        
        ArrayList< String[]> sFactorsList = findSFactorVisible(graphListPath,pariResultPath);
        //displaySFactorsList(sFactorsList);
        FileIO.saveSFactorsList(sFactorsList);
        //displaySFactorsList(FileIO.readSFactorsList("running/sFactors.txt"));
    }
    
    
       
    public static void countDifferentPolys(String pariResultPath) {
        ArrayList<PolynomialRecord> polynomialsList = ResultConverter.pariResultToPolynomials(pariResultPath);
        int size = polynomialsList.size();
        ArrayList<PolynomialRecord> havePolynomialsList = new ArrayList<PolynomialRecord>();
        havePolynomialsList.add(polynomialsList.get(0));
        System.out.println("We have " + polynomialsList.size() + " polynomials");
        for (int i=1; i < size; i++){
            boolean isDifferent = true;
            for ( int j= 0; j < havePolynomialsList.size(); j++ )
                if ( polynomialEqual( polynomialsList.get(i), havePolynomialsList.get(j) )  )
                {
                    isDifferent = false;
                }   
            if (isDifferent==true){havePolynomialsList.add(polynomialsList.get(i));}           
        }
        System.out.println("We have " + havePolynomialsList.size() +" different polynomials" );

    }
    
    public static ArrayList<String> retrieveDifferentStrings(ArrayList<String> stringsList) {        
        int size = stringsList.size();
        ArrayList<String> differentStringsList = new ArrayList<String>();     
        //System.out.println("We have " + stringsList.size() + " strings");
        if (stringsList.size() > 0){
            differentStringsList.add(stringsList.get(0));
            for (int i=1; i < size; i++){
                boolean isDifferent = true;
                for ( int j= 0; j < differentStringsList.size(); j++ )
                    if ( stringsList.get(i).equals(differentStringsList.get(j)) )
                    {
                        isDifferent = false;
                    }   
                if (isDifferent==true){differentStringsList.add(stringsList.get(i));}           
            }
        }
        return differentStringsList;
    }
        
    public static ArrayList<PolyIDs> IDsToPolysIDsList(String graphListPath,String pariResultPath) {
        ArrayList<PolyIDs> polynomialsList = ResultConverter.InitializePolyIDsList(graphListPath, pariResultPath);
        int size = polynomialsList.size();
        ArrayList<PolyIDs> havePolynomialsList = new ArrayList<PolyIDs>();
        havePolynomialsList.add(polynomialsList.get(0));
        System.out.println("We have " + polynomialsList.size() + " polynomials");
        for (int i=1; i < size; i++){
            boolean isDifferent = true;
            for ( int j= 0; j < havePolynomialsList.size(); j++ )
                if ( polynomialEqual( polynomialsList.get(i), havePolynomialsList.get(j) )  )
                {
                    isDifferent = false;
                    String graphiID = polynomialsList.get(i).getIDs().get(0);//graph ID
                    havePolynomialsList.get(j).getIDs().add(graphiID);//one poly can contain multi IDs
                }   
            if (isDifferent==true){havePolynomialsList.add(polynomialsList.get(i));}           
        }//havePolynomialsList ready, containing all different polynomials
        System.out.println("We have " + havePolynomialsList.size() +" different polynomials" );
        return havePolynomialsList;
    }
    
    public static void getTableDataFromSFactorsResult(String differentPolyIDsListPath, String sFactorsPolyIndexPath) {  
       ArrayList< String[]> sFactorsListPolyIndexLoad= FileIO.readSFactorsList(sFactorsPolyIndexPath);
       System.out.println("Different s-factorisations: "+sFactorsListPolyIndexLoad.size());
       //* 4.2) Number of different s-factorisied polynomials
       ArrayList< String> sfactorHeads = FileIO.readSFactorsListHead(sFactorsPolyIndexPath);
       ArrayList< String> differentSfactorHeads = retrieveDifferentStrings(sfactorHeads);
       System.out.println("Different s-factorised polynomials:" + differentSfactorHeads.size());
       //* 4.3) Number of s-factorisation graphs, graphs with polynomial which can be factorised
       ArrayList<PolyIDs> differentPolysListLoad = FileIO.readPolyIDsList(differentPolyIDsListPath);
       // count graphs according to polysIndex
       //int intPower = Integer.parseInt(factorPower);
       int countSFactorisedGraphs = 0;
       for (String record : differentSfactorHeads){
           int index = Integer.parseInt(record);
           int graphsOfThisPoly = differentPolysListLoad.get(index).getIDs().size();
           countSFactorisedGraphs = countSFactorisedGraphs + graphsOfThisPoly;           
       }
       System.out.println("Number of s-factorised graphs:" + countSFactorisedGraphs);
       //* 4.4) Number of s-factorisations, including duplications
       int countInvolvedGraphs = 0;
       //for every sFactorisation record, read three Indexs
       for (String[] record : sFactorsListPolyIndexLoad){
           int index0 = Integer.parseInt(record[0]);
           int index1 = Integer.parseInt(record[1]);
           int index2 = Integer.parseInt(record[2]);
           int graphsOfPolyIndex0 = differentPolysListLoad.get(index0).getIDs().size();
           int graphsOfPolyIndex1 = differentPolysListLoad.get(index1).getIDs().size();
           int graphsOfPolyIndex2= differentPolysListLoad.get(index2).getIDs().size();
           countInvolvedGraphs = countInvolvedGraphs + (graphsOfPolyIndex0 * graphsOfPolyIndex1 * graphsOfPolyIndex2) ;           
       }
       System.out.println("Number of s-factorisation duplications:" + countInvolvedGraphs);     

    }
    
    public static void getSFactorsAndTableData(String graphListPath, String pariResultPath, 
                    String saveDifferentPolyIDsListPath, String saveDFactorsPolyIndexPath){  
       ArrayList<PolyIDs> differentPolysList = IDsToPolysIDsList(graphListPath,pariResultPath); 
       FileIO.savePolyIDsList(differentPolysList, saveDifferentPolyIDsListPath);      
       ArrayList< String[]> sFactorsListPolyIndex = findSFactorPolyIDs(differentPolysList);
       FileIO.saveSFactorsList(sFactorsListPolyIndex,saveDFactorsPolyIndexPath); 
       System.out.println("Different s-factorisations: "+sFactorsListPolyIndex.size());
       //* 4.2) Number of different s-factorisied polynomials
       
       ArrayList< String> sFactorHeads = new ArrayList< String>();
        for ( String[] record : sFactorsListPolyIndex){
        String sfactorHead = record[0];
        sFactorHeads.add(sfactorHead );           
        }
             
       ArrayList< String> differentSfactorHeads = retrieveDifferentStrings(sFactorHeads);
       System.out.println("Different s-factorised polynomials:" + differentSfactorHeads.size());
       //* 4.3) Number of s-factorisation graphs, graphs with polynomial which can be factorised
       // count graphs according to polysIndex
       //int intPower = Integer.parseInt(factorPower);
       int countSFactorisedGraphs = 0;
       for (String record : differentSfactorHeads){
           int index = Integer.parseInt(record);
           int graphsOfThisPoly = differentPolysList.get(index).getIDs().size();
           countSFactorisedGraphs = countSFactorisedGraphs + graphsOfThisPoly;           
       }
       System.out.println("Number of s-factorised graphs:" + countSFactorisedGraphs);
       //* 4.4) Number of s-factorisations, including duplications
       int countInvolvedGraphs = 0;
       //for every sFactorisation record, read three Indexs
       for (String[] record : sFactorsListPolyIndex){
           int index0 = Integer.parseInt(record[0]);
           int index1 = Integer.parseInt(record[1]);
           int index2 = Integer.parseInt(record[2]);
           int graphsOfPolyIndex0 = differentPolysList.get(index0).getIDs().size();
           int graphsOfPolyIndex1 = differentPolysList.get(index1).getIDs().size();
           int graphsOfPolyIndex2= differentPolysList.get(index2).getIDs().size();
           countInvolvedGraphs = countInvolvedGraphs + (graphsOfPolyIndex0 * graphsOfPolyIndex1 * graphsOfPolyIndex2) ;           
       }
       System.out.println("Number of s-factorisation duplications:" + countInvolvedGraphs);     

    }
    
    
    
    

   public static void main(String[] args) throws IOException {

        
       // -----------------------------------------------
        
        // Find s-factorisations: Given a graph ID list, 
        // calculate the stability polynomials of these graphs and find s-factorisations
        
        //* 1)put graphList.txt in running folder   
        
        //* 2)graphList.txt To pariResult.txt
        //StabilityPolynomial.graphListToPariResult();
        
        //* 3)graphList.txt -> sFactors.txt
        // graphListToSFactors();
        //graphListToSFactorsVisible("running/graphList.txt","running/pariResult.txt");
        
        //---------------------------------------------------------
        
        // Count Different Polys: Given a polynomialsList, count how many DIFFERENT polys are there
        
        //* 1)put graphList.txt in running folder
        
        //* 2)graphList.txt To pariResult.txt
    //  StabilityPolynomial.graphListToPariResult();
        
        //* 3)given a pair of graphList.txt and pariResults, count howmany different polys
    //  countDifferentPolys("running/pariResult.txt"); 
        
        
        //ArrayList<PolynomialRecord> polynomialsList = ResultConverter.pariResultToPolynomials("running/pariResult.txt");
        
        // displaySFactorsList(FileIO.readSFactorsList("running/sFactors.txt"));
        
        //---------------------------------------------------------
        //Fast s-factorisation dectection: only check different polys while dectecting s-factorisation
        
        // Count Different Polys: Given a polynomialsList, count how many DIFFERENT polys are there
        
        //* 1)put graphList.txt in running folder
        
        //* 2)graphList.txt To pariResult.txt
       //StabilityPolynomial.graphListToPariResult();
        
        //* 3)given a pair of graphList.txt and pariResults, get differentPolyIDsList.txt and sFactorsPolyIndex.txt
        //    and  get all table data. para1 & para2 : read; para3 & para4 : save
        getSFactorsAndTableData("running/graphList.txt","running/pariResult.txt","running/differentPolyIDsList.txt","running/sFactorsPolyIndex.txt");
         //-----------------------------------------


    }

}

